var UX_LEGGERA = "0";
var UX_WEB2CS = "1";
var UX_FIZZER = "2";
var UX_HTML = "3";
var UX_PEC = "4";

var manage = false;
var classic = false;
var i18n_login = {
	global: {
	}
};

dojo.addOnLoad(function() {
	if (isBrowserSupported()) {
		var regex = new RegExp('[\\?&]classic=([^&#]*)'),
			results = regex.exec(location.search),
			noautoload = true;

		if (results && results[1] === "1") {
			classic = true;
		} else {
			noautoload = auto_login();
		}

		if (noautoload) {
			dojo.query(".login-background").style({"display": "flex"});
			if (!dojo.byId("dImsNXvlfN")) {
				dojo.query(".left-block-image").style({"display": "block"});
				dojo.query(".left-block > iframe").style({"display": "none"});
			} else {
				dojo.query(".left-block-image").style({"display": "none"});
				dojo.query(".left-block > iframe").style({"display": "block"});
			}

			if (classic) {
				dojo.query(".hide-in-classic").style({"visibility": "hidden"});
			}

			dojo.forEach(["login_default", "password_default", "login_domain", "password_domain"], function(id) {
				var node = dojo.byId(id),
					parent = node.parentNode;
				dojo.connect(node, "keyup", function(e) {
					if (e.keyCode === 13) {
						if (id === "login_domain" || id === "password_domain") {
							launchAdmin();
						} else {
							launchUser();
						}
					}
				});

				dojo.connect(node, "onfocus", "onInputFocus");
				dojo.connect(node, "onblur", "onInputBlur");
				dojo.connect(node, "onchange", "onInputChange");

				setTimeout(function() {
					onInputChange({target: node});
				}, 100);
			});

			login_initLocalization();
			login_initAdvancedPage();
		}
	} else {
		login_initLocalization();
		dojo.query(".obsolete-page").style({"display": "block"});
	}
});

if (!window.document.addEventListener){
	window.document.attachEvent("DOMContentLoaded", DOMContentLoadedListener);
} else {
	window.document.addEventListener("DOMContentLoaded", DOMContentLoadedListener, false);
}

function isBrowserSupported() {
	if ((dojo.isIE && dojo.isIE < 11) ||
		(dojo.isFF && dojo.isFF < 22) ||
		(dojo.isChrome && dojo.isChrome < 29) ||
		(dojo.isOpera && dojo.isChrome < 48)) {
		return false;
	}
	return true;
}

var JsonFormatter = {
	stringify: function(cipherParams) {
		// create json object with ciphertext
		var jsonObj = {
			ct: cipherParams.ciphertext.toString(CryptoJS.enc.Base64)
		};

		// optionally add iv and salt
		if (cipherParams.iv) {
			jsonObj.iv = cipherParams.iv.toString();
		}
		if (cipherParams.salt) {
			jsonObj.s = cipherParams.salt.toString();
		}

		// stringify json object
		return JSON.stringify(jsonObj);
	},

	parse: function(jsonStr) {
		// parse json string
		var jsonObj = JSON.parse(jsonStr),
			// extract ciphertext from json object, and create cipher params object
			cipherParams = CryptoJS.lib.CipherParams.create({
				ciphertext: CryptoJS.enc.Base64.parse(jsonObj.ct)
			});

		// optionally extract iv and salt
		if (jsonObj.iv) {
			cipherParams.iv = CryptoJS.enc.Hex.parse(jsonObj.iv);
		}
		if (jsonObj.s) {
			cipherParams.salt = CryptoJS.enc.Hex.parse(jsonObj.s);
		}

		return cipherParams;
	}
};

function encodeCredentials(loginParam) {
	try {
		var login_data = dojo.toJson(loginParam),
			encrypted = CryptoJS.AES.encrypt(login_data, loginParam.login, {format: JsonFormatter});
		return encrypted.toString();
	} catch(e) {
		console.debug("Error encodeCredentials:", e);
		return "";
	}
}

function login_setCredentials(value, expiry, domain) {
	var encrypted = typeof value === "object" ? encodeCredentials(value) : value;
	if (encrypted) {
		login_setCookie("XaM_Credentials", encrypted, expiry, domain);
	}
}

function login_getCookie(name) {
	var _cookies = " " + document.cookie;
	if (_cookies.indexOf(" " + name + "=") == -1) {
		return null;
	}

	var _start = _cookies.indexOf(" " + name + "=") + (name.length + 2),
		_finish = _cookies.substring(_start,_cookies.length);
	_finish = (_finish.indexOf(";") == -1) ? _cookies.length : _start + _finish.indexOf(";");

	return unescape(_cookies.substring(_start,_finish));
}

function login_setCookie(name,value,expiry,domain){
	var _datenow = new Date();
	_datenow.setTime(_datenow.getTime() + Math.round(86400000*expiry));
	var _expiry = _datenow.toGMTString();
	_expiry = "; expires=" + _expiry;
	var _path = "; path=/";
	if (domain) { _domain = "; domain=" + domain; } else { _domain = "";}
	var cookie = name + "=" + escape(value) + _domain + _path + _expiry;
	document.cookie = cookie ;
}

function login_initAdvancedPage() {
	login_initPage();

	var domain = login_getCookie("XaM_Domain");
	if (domain) {
		dojo.byId("login_domain").value = domain;
	}

	login_initRadios("XaM_Version_Domini", "webmail_version");
	login_initRadios("PoM_Version_Domini", "postmaster_version");
}

function login_initPage() {
	var login = login_getCookie("XaM_Login");
	if (login) {
		dojo.byId("login_default").value = login;
	}
}

function login_initRadios(cookie, radio) {
	var theme = login_getCookie(cookie) || 1,
		radios = document.getElementsByName(radio),
		idx = theme >= 0 && theme < radios.length ? theme : 1;
	radios[idx].checked = true;
}

function displayTab(id) {
	dojo.query(".right-block").toggleClass("manage-tab", id === "2");
}

function getLanguage() {
	return dojo.byId("language-button").className;
}

function login_showPopup(msg) {
	dojo.query(".feedback-block").removeClass("error").addClass("waiting");
	dojo.byId("feedback-text").innerHTML = msg;
}

function login_errorPopup(msg){
	dojo.query(".feedback-block").removeClass("waiting").addClass("error");
	dojo.byId("feedback-text").innerHTML = msg;
}

function login_hidePopup() {
	dojo.query(".feedback-block").removeClass("waiting error");
	dojo.byId("feedback-text").innerHTML = "";
}

function login_getSelectedUx(name) {
	var elements = document.getElementsByName(name),
		value;

	return dojo.some(elements, function(node) {
		if (node.checked) {
			value = node.value;
			return true;
		}
	}) ? value : UX_LEGGERA;
}

function launchLogin(loginType) {
	if (loginType == "1") {
		launchUser();
	} else {
		launchAdmin();
	}
}

function launchUser() {
	var lang = getLanguage(),
		i18n = i18n_login[lang],
		theme = login_getCookie("XaM_Theme") || "ext_aruba/classic",
		login = dojo.byId("login_default").value,
		passwd = dojo.byId("password_default").value,
		remember = dojo.byId("remember_me").checked,
		ux = login_getSelectedUx("webmail_version");

	if (login === "") {
		login_setCredentials("", -1);
		login_errorPopup(fstring(i18n["missing_login"]));
	} else if (passwd === "") {
		login_setCredentials("", -1);
		login_errorPopup(fstring(i18n["missing_password"]));
	} else {
		login_hidePopup();
		login_showPopup(fstring(i18n["requesting_data"]));

		login_setCookie("XaM_Version_Domini", ux, 365);
		login_setCookie("XaM_Login", login, 365);
		login_setLanguageCookie(lang);

		manage = false;
		if (classic || ux == UX_HTML) {
			login_html(login, passwd, lang, false);
		} else if (ux == UX_FIZZER) {
			login_fizzer(login, passwd, lang, false);
		} else if (ux == UX_PEC || isPecDomain(login)) {
			login_pec(login, passwd, lang, "ext_arubapec/classic.grey", remember);
		} else if (ux == UX_WEB2CS) {
			login_web2cs(login, passwd, lang, theme, remember);
		} else {
			login_leggera(login, passwd, lang, remember);
		}
	}
}

function launchAdmin() {
	var lang = getLanguage(),
		i18n = i18n_login[lang],
		theme = login_getCookie("XaM_Theme") || "ext_aruba/classic",
		domain = dojo.byId("login_domain").value,
		login = "postmaster@" + domain,
		passwd = dojo.byId("password_domain").value,
		ux = login_getSelectedUx("postmaster_version");

	if (domain === "") {
		login_hidePopup();
		login_errorPopup(fstring(i18n["missing_login"]));
	} else if (passwd === "") {
		login_hidePopup();
		login_errorPopup(fstring(i18n["missing_password"]));
	} else {
		login_hidePopup();
		login_showPopup(fstring(i18n["requesting_data"]));

		login_setCookie("XaM_Domain", domain, 365);
		login_setCookie("PoM_Version_Domini", ux, 365);
		login_setLanguageCookie(lang);

		manage = true;
		if (classic) {
			login_html(login, passwd, lang, false);
		} else if (ux == UX_WEB2CS) {
			login_web2cs(login, passwd, lang, theme, false);
		} else {
			login_leggera(login, passwd, lang, false);
		}
	}
}

function login_web2cs(login, passwd, lang, theme, remember) {
	var xfm = window.parent.xfmFrame.xfm,
		path, params, req;
	if (xfm) {
		if (theme) {
			path = theme.split(".")[0];
			xfm.loadDescriptor(path + "/descriptor.json");
		}
		params = {
			service: "web2cs",
			login: login,
			passwd: passwd,
			lang: lang,
			theme: theme,
			remember_me: remember
		};

		req = xfm.ajax();
		req.params = params;
		req.method = "POST";
		req.callback = function(str, req) {
			var response = xfm._evalJson(str),
				status = response.status,
				msg;

			if (!status || status.err_text || status.err_code) {
				msg = status ? (status.err_text ? status.err_text : "Error: " + status.err_code) :
					"An error has occurred, please retry later";
				login_errorCallback(msg);
			} else {
				if (remember && (response.status.mx === 0 || response.status.mx === undefined)) {
					login_setCredentials(params, 365);
				}
				if (response.url) {
					display_redirect(response.url, (manage ? {sso: 1} : {}));
				}
			}
		};
		req.errorCallback = login_errorCallback;
		req.request(xfm.getRequest("ems", "authenticate", params));
	} else {
		setTimeout(function() {
			login_web2cs(login, passwd, lang, theme, remember);
		}, 200);
	}
}

function login_errorCallback(msg) {
	login_setCredentials("", -1);
	login_errorPopup(msg);
}

function isBetaOptimizable() {
	if (dojo.isSafari || dojo.isIE >= 11) {
		return false;
	}
	return true;
}

function login_leggera(login, passwd, lang, remember) {
	var xfm = window.parent.xfmFrame.xfm,
		admin = manage ? 1 : 0,
		params;
	if (xfm) {
		xfm.loadDescriptor("ext_aruba/origin/descriptor.json");

		params = {
			login: login,
			passwd: passwd,
			service: "leggera",
			lang: lang,
			remember_me: remember,
			login_way: isBetaOptimizable() ? "optimized" : ""
		};

		xfm.rpc ({
			serviceName: "ems",
			serviceMethod: "authenticate",
			serviceExtraArgs: params,
			method: "POST",
			load: function(response) {
				if (response.status.err_code) {
					login_errorCallback(response.status.err_text);
					return;
				}

				if (response.status.mx === 0 || response.status.mx === undefined) {
					if (remember) {
						login_setCredentials(params, 365);
					}

					if (params.login_way == "optimized") {
						response.application.ext = "";
						response.application.ui = "layout/light";
						response.application.theme = "default";
						response.application.admin = admin;
						window.top.name = JSON.stringify(response);
						window.top.location = response.url + "/layout/light.html?_v_=" + response.version;
					} else {
						display_redirect(response.url + "/cgi-bin/ajaxmail", {
							Act_Msgs: 1,
							Tpl: "fizr",
							Theme: "layout/light.default",
							customer: "default",
							dynamicCustomization: response.dynamicCustomization,
							ext: "",
							declination: "",
							ui: "layout/light",
							theme: "default",
							Release: 1,
							ID: response.sessionid,
							SG_Lang: lang,
							admin: admin
						});
					}
				} else {
					display_redirect(response.url, {admin: admin});
				}
			}
		});
	} else {
		setTimeout(function() {
			login_leggera(login, passwd, lang, remember);
		}, 200);
	}
}

function auto_login() {
	var encrypted = login_getCookie("XaM_Credentials"),
		login = login_getCookie("XaM_Login"),
		decrypted, json, params, service, passwd, lang, theme;

	if (encrypted && login && encrypted !== "" && login !== "") {
		decrypted = CryptoJS.AES.decrypt(encrypted, login, {format: JsonFormatter});
		json = decrypted.toString(CryptoJS.enc.Utf8);
		params = dojo.fromJson(json);
		service = params.service;
		login = params.login;
		passwd = params.passwd;
		lang = params.lang;
		theme = params.theme;
		if (service === "web2cs") {
			login_web2cs(login, passwd, lang, theme, false);
		} else if (service === "pec") {
			login_pec(login, passwd, lang, theme);
		} else {
			login_leggera(login, passwd, lang);
		}
		return false;
	}
	return true;
}

function isPecDomain(login) {
	var parts = login.split("@"),
		domain = "@" + (parts.length > 1 ? parts[1] : "");

	return dojo.some([
		"@pec.aruba.it", "@pec.it", "@arubapec.it", "@mypec.eu", "@gigapec.it",
		"@pec.comunemartinafranca.gov.it", "pec\\.(.*)\\.it", "@jhhhhhhkl.it",
		"@casellapec.com","@pecditta.com", "@psypec.it", "@oappc-rc.it"
	], function(item) {
		var re = new RegExp(item);
		return domain.match(re);
	});
}

function login_pec(login, password, language, look, remember_me) {
	var xfm = window.parent.xfmFrame.xfm,
		params;
	if (xfm) {
		xfm.loadDescriptor("ext_aruba/origin/descriptor.json");

		params = {
			login: login,
			passwd: password,
			service: "pec",
			theme: look,
			lang: language,
			remember_me: remember_me
		};

		try {
			xfm.rpc({
				serviceName: "ems",
				serviceMethod: "authenticate",
				serviceExtraArgs: params,
				method: "POST",
				load: function(response) {
					if (!response.status.err_code) {
						// Disable for PEC users for security reasons
						/* if (remember_me) {
							login_setCredentials(params, 365);
						}*/
						display_redirect(response.url);
					} else {
						login_errorCallback(response.status.err_text);
					}
				}
			});
		}
		catch(e) {
			console.debug("login_pec error : " + e);
		}
	} else {
		setTimeout(function() {
			login_pec(login, password, language, look, remember_me);
		}, 200);
	}
}

function login_html(login, password, language, remember_me) {
	var xfm = window.parent.xfmFrame.xfm,
		params, pid;
	if (xfm) {
		pid = document.getElementById('login_pid').value;
		xfm.loadDescriptor("ext_aruba/origin/descriptor.json");

		params = {
			login: login,
			passwd: password,
			lang: language,
			useHTMLTpl: 1,
			pid: pid,
			remember_me: remember_me
		};

		try {
			xfm.rpc ({
				serviceName: "ems",
				serviceMethod: "authenticate",
				serviceExtraArgs: params,
				method: "POST",
				load: function(response) {
					if (response.status.err_code) {
						login_errorCallback(response.status.err_text);
						return;
					}

					if (response.status.mx === 0 || response.status.mx === undefined) {
						if (remember_me) {
							login_setCredentials(params, 365);
						}

						display_redirect(response.url + "/cgi-bin/webmail", {
							Act_Msgs: 1,
							Tpl: "login",
							PID: pid,
							ID: response.sessionid,
							SG_Lang: language
						});
					} else {
						display_redirect(response.url);
					}
				}
			});
		}
		catch(e) {
			console.debug("error : " + e);
		}
	} else {
		setTimeout(function() {
			login_html(login, password, language, remember_me);
		}, 200);
	}
}

function login_fizzer(login, password, language, remember_me) {
	var xfm = window.parent.xfmFrame.xfm;
	if (xfm) {
		xfm.loadDescriptor("ext_aruba/origin/descriptor.json");

		var loginParam = {
			login: login,
			passwd: password,
			service: "lizzam",
			lang: language,
			remember_me: remember_me
		};

		try {
			xfm.rpc ({
				serviceName: "ems",
				serviceMethod: "authenticate",
				serviceExtraArgs: loginParam,
				method: "POST",
				load: function(response) {
					if (response.status.err_code) {
						login_errorCallback(response.status.err_text);
						return;
					}

					if (response.status.mx === 0 || response.status.mx === undefined || response.url === undefined) {
						if (remember_me) {
							login_setCredentials(params, 365);
						}

						window.top.name = dojo.toJson(response);
						display_redirect(response.url + "/cgi-bin/ajaxmail", {
							Act_Msgs: 1,
							Tpl: "fizr",
							Theme: "layout/light.default:orange",
							customer: "aruba",
							ext: "aruba",
							declination: "orange",
							ui: "layout/light",
							theme: "default",
							Release: 1,
							ID: response.sessionid,
							ImapReq: 1,
							SG_Lang: language
						});
					} else {
						display_redirect(response.url);
					}
				}
			});
		}
		catch(e) {
			console.debug("error : " + e);
		}
	} else {
		recall = function() {
			login_fizzer(login, password, language, remember_me);
		}
		setTimeout("recall()", 200);
	}
}

function display_redirect(url, params) {
	var form = dojo.byId("redirect"),
		parts = url.split("?"),
		action = parts[0],
		i, input;
	if (form) {
		params = params || {};
		if (parts.length > 1) {
			dojo.forEach(parts[1].split("&"), function(pair) {
				var split = pair.split("=");
				params[decodeURIComponent(split[0])] = decodeURIComponent(split[1]);
			});
		}

		for (i in params) {
			dojo.create("input", {
				"type": "hidden",
				"name": i,
				"value": params[i]
			}, form);
		}
		form.action = action;
		form.submit();
	}
}

function showPassword(id) {
	var node = dojo.byId(id),
		isVisible;
	if (node) {
		isVisible = node.type === "text" ? true : false;
		node.type = isVisible ? "password" : "text";
	}
}

function onInputFocus(e) {
	var node = e.target;
	dojo.addClass(node.parentNode, "focused");
}

function onInputBlur(e) {
	var node = e.target;
	dojo.removeClass(node.parentNode, "focused");
}

function onInputChange(e) {
	var node = e.target;
	dojo.toggleClass(node.parentNode, "filled", node.value !== "");
}

function DOMContentLoadedListener() {
	window.setTimeout(function() {
		dojo.query("input[type=text], input[type=password]").forEach(function(node) {
			onInputChange({target: node});
		});
	}, 200);
}

function login_setLanguageCookie(lang) {
	var hostname = window.location.hostname,
		domain = hostname || "",
		parts = domain.split(".").reverse();

	if (parts.length > 1) {
		domain = parts[1] + "." + parts[0];
		if (parts.length > 2 && hostname.toLowerCase().indexOf(".co.uk") != -1) {
			domain = parts[2] + "." + domain;
		}
	}
	login_setCookie("XaM_Language", lang, 365, domain);
}

function loginGetLanguage(lang, callback) {
	if (i18n_login[lang]) {
		callback(i18n_login[lang]);
	} else {
		var xobj = new XMLHttpRequest();
		xobj.open("GET", "ext_aruba/js/nls/" + (lang === "en" ? "" : lang + "/") + "login.js?_v_=v4r2b57.20200506_1230", true);
		xobj.onreadystatechange = function () {
			if (xobj.readyState == 4 && xobj.status == "200") {
				i18n_login[lang] = eval(xobj.responseText);
				callback(i18n_login[lang]);
			}
		};
		xobj.send(null);
	}
}

function login_initLocalization() {
	var languages = [
			{code : "en", name : "English"},
			{code : "es", name : "Espa&#241;ol"},
			{code : "it", name : "Italiano"}
		],
		lang = login_getCookie("XaM_Language") ||
			(!navigator.browserLanguage ?
				navigator.language.split("-")[0] :
				navigator.browserLanguage.split("-")[0]),
		ul = dojo.create("ul");

	switch (lang) {
		case "it":
		case "es":
			break;
		default:
			lang = "en";
			break;
	}

	dojo.forEach(languages, function(language) {
		var li = dojo.create("li", {
				onclick: function(e) {
					changeLanguage(language.code, language.name);
					dojo.stopEvent(e);
				}
			});
		dojo.create("div", {
			id: language.code,
			innerHTML: language.name
		}, li);
		ul.appendChild(li);
		if (lang == language.code) {
			dojo.byId("language_select").innerHTML = language.name;
			dojo.addClass("language-button", language.code);
			loginGetLanguage(lang, login_localize);
		}
	});

	dojo.byId("menu_language").appendChild(ul);
}

function changeLanguage(param1, param2) {
	dojo.toggleClass("menu_language", "show");
	dojo.removeClass("language-button");
	dojo.addClass("language-button", param1);
	dojo.byId("language_select").innerHTML = param2;
	loginGetLanguage(param1, login_localize);
}

function showLanguage() {
	dojo.toggleClass("menu_language", "show");
}

function login_localize(i18n) {
	dojo.query("[data-i18n]").forEach(function(node) {
		node.innerHTML = fstring(i18n[dojo.attr(node, "data-i18n")]);
	});

	dojo.query("[data-i18n-placeholder]").forEach(function(node) {
		node.placeholder = fstring(i18n[dojo.attr(node, "data-i18n-placeholder")]);
	});
}

function fstring(param) {
	param = param.replace(/\{year\}/g, function() {return new Date().getFullYear();});
	return dojo.replace(param, i18n_login.global);
}